include zgen.inc

.code

align 4

start:

      SingleInstanceOnly offset ClassName
      mov hInstance,   FUNC(GetModuleHandle, NULL)
      mov CommandLine, FUNC(GetCommandLine)
   
      invoke InitCommonControlsEx,offset ICCE

	   invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	   invoke ExitProcess,eax

align 4
ZGenerator PROC uses eax ecx edx
LOCAL systime:SYSTEMTIME

		@Generate:
		
		xor eax,eax
		xor edx,edx
		xor ecx,ecx
		
		call GetTickCount
		push eax

		invoke GetLocalTime, ADDR systime
		movzx ecx, systime.wMilliseconds
		movzx edx, systime.wSecond

		pop eax


;~~~~~~~~~~~~ Seeding Prozedur
		xor ecx,edx
		add eax,ecx
		add eax,edx
		xor eax,edx
		xor edx,ecx
		add eax,edx
		add eax,ecx
		sub edx,ecx
		xor eax,edx

		test eax,eax
		jz @Generate

		invoke nseed, eax
		NOP
		NOP
		invoke nrandom, 62
		NOP
		NOP
		
		
		cmp eax,49
		jg short @Generate

		cmp eax,1
		jl short @Generate

		mov Zufallszahl, eax

	ret

ZGenerator endp

align 4
_6aus49generieren proc uses eax
	
	call ZGenerator
	push Zufallszahl
	pop [Tabelle]

	@Z2:
	call ZGenerator
	mov eax,Zufallszahl

	cmp eax, [Tabelle]
	je short @Z2

	mov [Tabelle+4],eax

	@Z3:
	call ZGenerator
	mov eax,Zufallszahl


	cmp eax, [Tabelle]
	je short @Z3

	cmp eax, [Tabelle+4]
	je short @Z3

	mov [Tabelle+8],eax


	@Z4:
	call ZGenerator
	mov eax,Zufallszahl


	cmp eax, [Tabelle]
	je short @Z4

	cmp eax, [Tabelle+4]
	je short @Z4

	cmp eax, [Tabelle+8]
	je short @Z4

	mov [Tabelle+12],eax


	@Z5:
	call ZGenerator
	mov eax,Zufallszahl


	cmp eax, [Tabelle]
	je short @Z5

	cmp eax, [Tabelle+4]
	je short @Z5

	cmp eax, [Tabelle+8]
	je short @Z5

	cmp eax, [Tabelle+12]
	je short @Z5

	mov [Tabelle+16],eax


	@Z6:
	call ZGenerator
	mov eax,Zufallszahl

	cmp eax, [Tabelle]
	je short @Z6

	cmp eax, [Tabelle+4]
	je short @Z6

	cmp eax, [Tabelle+8]
	je short @Z6

	cmp eax, [Tabelle+12]
	je short @Z6

	cmp eax, [Tabelle+16]
	je short @Z6

	mov [Tabelle+20],eax

	ret

_6aus49generieren endp

align 4
RadixExchangeSort PROC Arr:DWORD, count:DWORD

    mov    eax, Arr
    mov    ebx, count
    lea    ebx, [eax + ebx*4 - 4]

    push   31
    push   ebx
    push   eax
    call   RadixExchangeSort_Sort



@Return:
  ret

RadixExchangeSort ENDP

align 4
RadixExchangeSort_Sort PROC left:DWORD, right:DWORD, bit:DWORD

    mov    eax, left
    mov    ebx, right
    cmp    ebx, eax
    jna    @Return

    mov    edx, 1
    mov    ecx, bit
    shl    edx, cl

    sub    eax, 4
    add    ebx, 4

  @Loop1:

    @Loop2:
        add    eax, 4
        cmp    eax, ebx
        jae    @F

        test   DWORD PTR [eax], edx
        jz     @Loop2

    @Loop3:
        sub    ebx, 4
        cmp    eax, ebx
        jae    @F

        test   DWORD PTR [ebx], edx
        jnz    @Loop3

      mov    esi, DWORD PTR [eax]
      mov    edi, DWORD PTR [ebx]
      mov    DWORD PTR [eax], edi
      mov    DWORD PTR [ebx], esi

      jmp    @Loop1


    @@:
      test   ecx, ecx
      jz     @Return

      sub    ecx, 1
      push   eax
      push   ecx

        mov    ebx, left
        sub    eax, 4

        push   ecx
        push   eax
        push   ebx
        call   RadixExchangeSort_Sort

      pop    ecx
      pop    eax

      mov    ebx, right

      push   ecx
      push   ebx
      push   eax
      call   RadixExchangeSort_Sort

      

@Return:
    ret

RadixExchangeSort_Sort ENDP

; ----------------------------------------------------------------------------
align 4
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL winmainhwnd:HWND
   LOCAL wc:WNDCLASSEX


			mov		wc.cbSize,		SIZEOF WNDCLASSEX
			mov		wc.style,		CS_BYTEALIGNWINDOW or \
											CS_BYTEALIGNCLIENT or \
											CS_HREDRAW or \
											CS_VREDRAW

			mov   wc.lpfnWndProc,	OFFSET WndProc
			mov   wc.cbClsExtra,		NULL
			mov   wc.cbWndExtra,		DLGWINDOWEXTRA
			push hInstance
			pop wc.hInstance
			mov   wc.hbrBackground,	COLOR_BTNFACE+1
			mov   wc.lpszMenuName,	NULL
			mov   wc.lpszClassName,	OFFSET ClassName

			invoke LoadIcon,			hInstance,500
			mov   wc.hIcon,			eax
			mov   wc.hIconSm,			eax

			invoke LoadCursor,NULL,IDC_ARROW
			mov   wc.hCursor, eax
	
	      invoke RegisterClassEx, addr wc

         invoke CreateDialogParam,hInstance,1000,NULL,offset WndProc,NULL

                  mov winmainhwnd,eax
                  invoke ShowWindow, winmainhwnd,SW_SHOWNORMAL
                  invoke UpdateWindow, winmainhwnd
	
	call MsgLoop	

	ret
WinMain endp
; ----------------------------------------------------------------------------
align 4
MsgLoop proc uses esi edi

    LOCAL msg:MSG

    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp short @jumpin

    StartLoop:
    
      invoke TranslateMessage, esi
    ; --------------------------------------
    ; perform any required key processing here
    ; --------------------------------------
      invoke DispatchMessage,  esi
    @jumpin:
      invoke GetMessage,esi,edi,edi,edi
      test eax, eax
      jnz short StartLoop

    mov eax, msg.wParam

    ret

MsgLoop endp
; ----------------------------------------------------------------------------
align 4
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

 Switch uMsg
   
	Case WM_DESTROY
      invoke PostQuitMessage,NULL
      return 0

	Case WM_COMMAND
	
			mov eax,wParam
			and eax,0FFFFh

			.if eax == 103
			 invoke SendMessage,hWnd,WM_DESTROY,NULL,NULL
			.endif

			.if eax == 102
				call _6aus49generieren

				invoke RadixExchangeSort,offset Tabelle,6

         szText zz,'%i, %i, %i, %i, %i, %i'
			invoke wsprintf,addr buffer,offset zz, [Tabelle],\
			                                       [Tabelle+4],\
			                                       [Tabelle+8],\
			                                       [Tabelle+12],\
			                                       [Tabelle+16],\
			                                       [Tabelle+20]

         szText MBTEXT,"Ihre Zahlen"
			invoke MessageBox, hWnd, addr buffer, addr MBTEXT,MB_OK

			.endif
	Endsw
	
      invoke DefWindowProc,hWnd,uMsg,wParam,lParam
      ret

WndProc endp
; ----------------------------------------------------------------------------

end start