     .386                                     ; create 32 bit code
     .model flat, stdcall                      ; 32 bit memory model
     option casemap :none                      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc       ; main windows include file
      include \masm32\include\masm32.inc        ; masm32 library include

    ; -------------------------
    ; Windows API include files
    ; -------------------------
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\ole32.inc
      include \masm32\include\msvcrt.inc

      include \masm32\include\dialogs.inc       ; macro file for dialogs
      include \masm32\macros\macros.asm         ; masm32 macro file
      include \masm32\macros\ucmacros.asm	; masm32 unicode support file

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib         ; masm32 static library

    ; ------------------------------------------
    ; import libraries for Windows API functions
    ; ------------------------------------------
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\ole32.lib
      includelib \masm32\lib\msvcrt.lib

; 
; PROTOs
; 
WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
nrandom						PROTO :DWORD
nseed							PROTO :DWORD
ZGenerator					PROTO
_6aus49generieren			PROTO
RadixExchangeSort			PROTO :DWORD,:DWORD
RadixExchangeSort_Sort	PROTO :DWORD,:DWORD,:DWORD


SingleInstanceOnly MACRO lpClassName
        pushad
        invoke FindWindow,lpClassName,NULL
        test eax,eax
        jz @F
        
        
        NOP
        NOP
        NOP
        NOP
          push eax
         invoke ShowWindow,eax,SW_RESTORE
          		pop eax
          		invoke SetForegroundWindow,eax
				xor eax,eax
				popad
          ret
        @@:
        
        NOP
        NOP
        NOP
        NOP
        popad
      ENDM

; ----------------------------------------------------------------------------
; ----------------------------------------------------------------------------
.const

; ----------------------------------------------------------------------------
; ----------------------------------------------------------------------------
align 4

.data
ClassName db "zgen_MainWinClass",0

	ICCE 					INITCOMMONCONTROLSEX \
							<SIZEOF INITCOMMONCONTROLSEX, \
							ICC_STANDARD_CLASSES or ICC_WIN95_CLASSES>
; ----------------------------------------------------------------------------
; ----------------------------------------------------------------------------
align 4

.data?

	hInstance			HINSTANCE	?
	CommandLine			LPSTR			?
   Zufallszahl			dd          ?
   Tabelle 				dd 6 dup    (?)
   buffer 				db 32 dup   (?)
; ----------------------------------------------------------------------------
; ----------------------------------------------------------------------------